import { useEffect } from 'react';
import { useLatest } from '../generic/useLatest';
// export type UseEventOptions<T> = Parameters<AddEventListener<T>>[2];
export function useEvent(name, handler, target = window) {
    const latest = useLatest(handler);
    useEffect(() => {
        var _a;
        const _target = target || undefined;
        const _names = Array.isArray(name) ? name : [name];
        const inHandler = (event) => { var _a; return (_a = latest.current) === null || _a === void 0 ? void 0 : _a.call(latest, event); };
        const _on = (_a = _target === null || _target === void 0 ? void 0 : _target.addEventListener) !== null && _a !== void 0 ? _a : _target === null || _target === void 0 ? void 0 : _target.on;
        _on && _names.forEach(name => _on.call(_target, name, inHandler));
        return () => {
            var _a;
            const _off = (_a = _target === null || _target === void 0 ? void 0 : _target.removeEventListener) !== null && _a !== void 0 ? _a : _target === null || _target === void 0 ? void 0 : _target.off;
            _off && _names.forEach(name => _off.call(_target, name, inHandler));
        };
    }, [name, target]);
}
